#pragma interface
#ifndef TLMPWEB_H
#define TLMPWEB_H

#include <misc.h>
#include <time.h>

// Runtime for .hc pages

class W_VAR{
protected:
	bool was_set;
	const char *name;
	W_VAR *next;
	const char *flags;
public:
	virtual void setinitval (const char *val)=0;
	virtual void getvalstr (SSTRING &s) const =0;
	/*~PROTOBEG~ W_VAR */
public:
	W_VAR (const char *_name, const char *_flags);
protected:
	void after_init (void);
public:
	const char *getflags (void)const;
	const char *getname (void)const;
	W_VAR *getnext (void)const;
	bool isset (void);
	void setempty (void);
	virtual ~W_VAR (void);
	/*~PROTOEND~ W_VAR */
};

class W_SSTRING: public SSTRING, public W_VAR{
	/*~PROTOBEG~ W_SSTRING */
public:
	W_SSTRING (const char *_name);
	W_SSTRING (const char *_name,
		 const char *value,
		 const char *_flags);
	W_SSTRING (const char *_name, const char *value);
	void getvalstr (SSTRING&s)const;
	void setempty (void);
	void setinitval (const char *v);
	/*~PROTOEND~ W_SSTRING */
};

class W_INT: public W_VAR{
	int val;
	/*~PROTOBEG~ W_INT */
public:
	W_INT (const char *_name);
	W_INT (const char *_name,
		 int value,
		 const char *_flags);
	W_INT (const char *_name, int value);
	int getval (void);
	void getvalstr (SSTRING&s)const;
	W_INT&operator = (int v);
	operator int (void);
	void setinitval (const char *v);
	/*~PROTOEND~ W_INT */
};


#define _TLMP_frame2

struct _F_frame2{
	#define _F_frame2_top(x) void x top ()
	virtual _F_frame2_top( )=0;
	#define _F_frame2_bottom(x) void x bottom ()
	virtual _F_frame2_bottom( )=0;
};

#define _TLMP_frame4

enum FRAME_TARGET {target_top_left,target_body,target_left,target_top};

struct _F_frame4{
	void settarget (FRAME_TARGET target);
	#define _F_frame4_left(x) void x left ()
	virtual _F_frame4_left( )=0;
	#define _F_frame4_top(x) void x top ()
	virtual _F_frame4_top( )=0;
	#define _F_frame4_body(x) void x body ()
	virtual _F_frame4_body( )=0;
	#define _F_frame4_top_left(x) void x top_left ()
	virtual _F_frame4_top_left( )=0;
};

#define _TLMP_frame3

struct _F_frame3{
	#define _F_frame3_left(x) void x left ()
	virtual _F_frame3_left( )=0;
	#define _F_frame3_top(x) void x top ()
	virtual _F_frame3_top( )=0;
	#define _F_frame3_body(x) void x body ()
	virtual _F_frame3_body( )=0;
};


#define _TLMP_vframe4

struct _F_vframe4{
	#define _F_vframe4_left(x) void x left ()
	virtual _F_vframe4_left( )=0;
	#define _F_vframe4_top(x) void x top ()
	virtual _F_vframe4_top( )=0;
	#define _F_vframe4_body(x) void x body ()
	virtual _F_vframe4_body( )=0;
	#define _F_vframe4_top_left(x) void x top_left ()
	virtual _F_vframe4_top_left( )=0;
};

#define _TLMP_vframe2

struct _F_vframe2{
	#define _F_vframe2_top(x) void x top ()
	virtual _F_vframe2_top( )=0;
	#define _F_vframe2_body(x) void x body (int menu)
	virtual _F_vframe2_body( )=0;
};


#define _TLMP_vmenu

struct _F_vmenu{
	#define _F_vmenu_intro(x) void x intro()
	virtual _F_vmenu_intro( )=0;
	#define _F_vmenu_mailing(x) void x mailing()
	virtual _F_vmenu_mailing( )=0;
	#define _F_vmenu_download(x) void x download()
	virtual _F_vmenu_download( )=0;
	#define _F_vmenu_doc(x) void x doc()
	virtual _F_vmenu_doc( ) = 0;
	#define _F_vmenu_changes(x) void x changes()
	virtual _F_vmenu_changes( )=0;
	#define _F_vmenu_news(x) void x news()
	virtual _F_vmenu_news( )=0;
};

#define _TLMP_hmenu

struct _F_hmenu{
	#define _F_hmenu_home(x) void x home()
	virtual _F_hmenu_home( )=0;
	#define _F_hmenu_search(x) void x search()
	virtual _F_hmenu_search( )=0;
};


#define _TLMP_form

struct _F_form{
	// We can add as much info in priv without losing the  binary
	// compatibility
public:
	struct _F_form_private *priv;
	/*~PROTOBEG~ _F_form */
public:
	_F_form (void);
	virtual void bottom (void);
	void button_submit (const char *title);
	void button_submit (void);
	void field_checkbox (const char *name,
		 bool selected,
		 const char *opt);
	void field_file (W_VAR&v);
	void field_file (const char *name);
	void field_hidden (const char *name,
		 const char *value);
	void field_list (const char *name,
		 const char *value,
		 const char *opt);
	void field_list_end (void);
	void field_list_item (const char *sel_value);
	void field_list_item (const char *sel_value,
		 const char *sel_desc);
	void field_password (const W_VAR&var,
		 const char *opt);
	void field_password (const char *name,
		 const char *opt);
	void field_radio (const char *name,
		 const char *value,
		 bool selected,
		 const char *opt);
	void field_string (const W_VAR&var, const char *opt);
	void field_string (const char *name,
		 const char *value,
		 const char *opt);
	void field_textarea (const W_VAR&var,
		 int rows,
		 int cols,
		 const char *opt);
	void field_textarea (const char *name,
		 int rows,
		 int cols,
		 const char *opt);
	void field_textarea_body (const char *ctl, ...);
	void field_textarea_end (void);
	void fputs (const char *s, FILE *f);
	virtual void load (void);
	void no_submit (void);
	void printf (const char *ctl, ...);
	void setfield (const char *name,
		 const char *type,
		 const char *value,
		 const char *opt);
	virtual void top (void);
	/*~PROTOEND~ _F_form */
	#define _F_form_load(x) void x load()
	#define _F_form_top(x) void x top()
	#define _F_form_bottom(x) void x bottom()
	#define _F_form_setup(x) void x setup(bool first, bool drawing)
	virtual _F_form_setup( ) = 0;
	#define _F_form_validate(x) bool x validate()
	virtual _F_form_validate( ) = 0;
	#define _F_form_process(x) void x process()
	virtual _F_form_process( ) = 0;
};

class URL_ENCODE{
	SSTRINGS tb;
	/*~PROTOBEG~ URL_ENCODE */
public:
	URL_ENCODE (void);
	const char *enc (const SSTRING&s);
	const char *enc (const char *s);
	/*~PROTOEND~ URL_ENCODE */
};
	
#define _TLMP_websession

struct WEBSESSION_INFO{
	const char *realm;
	const char *user;
	int key;			// Unique key used to store the session variables
	char random[20];	// random content assign with this key to make
						// key unguessable
};

struct _F_websession{
	void setrealm(const char *realm);
	#define _F_websession_init(nom) int nom init(WEBSESSION_INFO &info)
	virtual _F_websession_init( )=0;
	#define _F_websession_auth(nom) bool nom auth(WEBSESSION_INFO &info, const char *passwd)
	virtual _F_websession_auth( );
	#define _F_websession_save(nom) int nom save(WEBSESSION_INFO &info, W_VAR *tbvar[], int nbvar)
	virtual _F_websession_save( );
	#define _F_websession_load(nom) int nom load(WEBSESSION_INFO &info, W_VAR *tbvar[], int nbvar)
	virtual _F_websession_load( );
	#define _F_websession_exec(nom) void nom exec(WEBSESSION_INFO &info)
	virtual _F_websession_exec( )=0;
};

#define _TLMP_websteps

struct _F_websteps{
	class websteps_private *priv;
	void gotostep(int step);
	void url_gotostep (int targetstep, const char *s, ...);
	#define _F_websteps_setstep(nom) void nom setstep(int &step)
	virtual _F_websteps_setstep( );
	#define _F_websteps_step1(nom) void nom step1()
	virtual _F_websteps_step1( )=0;
	#define _F_websteps_step2(nom) void nom step2()
	virtual _F_websteps_step2( )=0;
	#define _F_websteps_step3(nom) void nom step3()
	virtual _F_websteps_step3( );
	#define _F_websteps_step4(nom) void nom step4()
	virtual _F_websteps_step4( );
	#define _F_websteps_step5(nom) void nom step5()
	virtual _F_websteps_step5( );
	#define _F_websteps_step6(nom) void nom step6()
	virtual _F_websteps_step6( );
	#define _F_websteps_step7(nom) void nom step7()
	virtual _F_websteps_step7( );
	#define _F_websteps_step8(nom) void nom step8()
	virtual _F_websteps_step8( );
	#define _F_websteps_step9(nom) void nom step9()
	virtual _F_websteps_step9( );
	#define _F_websteps_step10(nom) void nom step10()
	virtual _F_websteps_step10( );
	#define _F_websteps_step11(nom) void nom step11()
	virtual _F_websteps_step11( );
	#define _F_websteps_step12(nom) void nom step12()
	virtual _F_websteps_step12( );
	#define _F_websteps_step13(nom) void nom step13()
	virtual _F_websteps_step13( );
	#define _F_websteps_step14(nom) void nom step14()
	virtual _F_websteps_step14( );
	#define _F_websteps_step15(nom) void nom step15()
	virtual _F_websteps_step15( );
};

#define _TLMP_webstepsinclude

struct _F_webstepsinclude{
	class webstepsinclude_private *priv;
	void gotostep(int step);
	void url_gotostep (int targetstep, const char *s, ...);
	#define _F_webstepsinclude_step1(nom) void nom step1()
	virtual _F_webstepsinclude_step1( )=0;
	#define _F_webstepsinclude_step2(nom) void nom step2()
	virtual _F_webstepsinclude_step2( );
	#define _F_webstepsinclude_step3(nom) void nom step3()
	virtual _F_webstepsinclude_step3( );
	#define _F_webstepsinclude_step4(nom) void nom step4()
	virtual _F_webstepsinclude_step4( );
	#define _F_webstepsinclude_step5(nom) void nom step5()
	virtual _F_webstepsinclude_step5( );
	#define _F_webstepsinclude_step6(nom) void nom step6()
	virtual _F_webstepsinclude_step6( );
	#define _F_webstepsinclude_step7(nom) void nom step7()
	virtual _F_webstepsinclude_step7( );
	#define _F_webstepsinclude_step8(nom) void nom step8()
	virtual _F_webstepsinclude_step8( );
	#define _F_webstepsinclude_step9(nom) void nom step9()
	virtual _F_webstepsinclude_step9( );
	#define _F_webstepsinclude_step10(nom) void nom step10()
	virtual _F_webstepsinclude_step10( );
};

class FORM_HIDDEN: public ARRAY_OBJ{
	W_VAR &var;
	SSTRING s;
	/*~PROTOBEG~ FORM_HIDDEN */
public:
	FORM_HIDDEN (W_VAR&_var);
	const char *getname (void);
	const char *getval (void);
	~FORM_HIDDEN (void);
	/*~PROTOEND~ FORM_HIDDEN */
};

#define _TLMP_weblogin

struct _F_weblogin{
	class weblogin_private *priv;
	void field_user();
	void field_pass();
	#define _F_weblogin_setup(x) void x setup(W_SSTRING &user, W_SSTRING &passw)
	virtual _F_weblogin_setup( )=0;
	#define _F_weblogin_validate(x) bool x validate(const char *user, const char *pass)
	virtual _F_weblogin_validate( )=0;
	#define _F_weblogin_exec(x) void x exec (const char *user, const char *passw)
	virtual _F_weblogin_exec( )=0;
	#define _F_weblogin_top(x) void x top ()
	virtual _F_weblogin_top( );
	#define _F_weblogin_bottom(x) void x bottom ()
	virtual _F_weblogin_bottom( );
};

#define _TLMP_websecure

struct _F_websecure{
	class websecure_private *priv;
	#define _F_websecure_exec(x) void x exec ()
	virtual _F_websecure_exec( )=0;
};

#define _TLMP_webinclude

struct _F_webinclude{
	class webinclude_private *priv;
	#define _F_webinclude_mark1(x) void x mark1 ()
	virtual _F_webinclude_mark1( );
	#define _F_webinclude_mark2(x) void x mark2 ()
	virtual _F_webinclude_mark2( );
	#define _F_webinclude_mark3(x) void x mark3 ()
	virtual _F_webinclude_mark3( );
	#define _F_webinclude_mark4(x) void x mark4 ()
	virtual _F_webinclude_mark4( );
	#define _F_webinclude_mark5(x) void x mark5 ()
	virtual _F_webinclude_mark5( );
	#define _F_webinclude_mark6(x) void x mark6 ()
	virtual _F_webinclude_mark6( );
	#define _F_webinclude_mark7(x) void x mark7 ()
	virtual _F_webinclude_mark7( );
	#define _F_webinclude_mark8(x) void x mark8 ()
	virtual _F_webinclude_mark8( );
	#define _F_webinclude_mark9(x) void x mark9 ()
	virtual _F_webinclude_mark9( );
	#define _F_webinclude_other(x) void x other (const char *mark)
	virtual _F_webinclude_other( );
};

#define _TLMP_webproxy

struct _F_webproxy{
	class webproxy_private *priv;
	#define _F_webproxy_missing(x) void x missing (const char *url)
	virtual _F_webproxy_missing( );
	#define _F_webproxy_start(x) void x start (const char *url)
	virtual _F_webproxy_start( );
	#define _F_webproxy_end(x) void x end (const char *url)
	virtual _F_webproxy_end( );
	#define _F_webproxy_oneline(x) void x oneline (const char *url, const char *line)
	virtual _F_webproxy_oneline( );
	#define _F_webproxy_header(x) void x header (const char *url, const char *line)
	virtual _F_webproxy_header( );
};


extern SSTRING frame_target;


#include "tlmpweb.p"

#endif

